# Copyright (C) 2023-2024 Cochise Ruhulessin
#
# All rights reserved. No warranty, explicit or implicit, provided. In
# no event shall the author(s) be liable for any claim or damages.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
from typing import Any

from .apimodel import APIModel
from .apimodelfield import APIModelField
from .apiresource import APIResource as APIResourceModel
from .apimodelinspector import APIModelInspector
from .apirootresource import APIRootResource as APIRootResourceModel
from .apiversionedmeta import APIVersionedMeta
from .clusterobjectreference import ClusterObjectReference
from .localobjectreference import LocalObjectReference
from .objectmeta import ObjectMeta
from .objectreference import ObjectReference
from .refs import *
from .resourcespec import ResourceSpec
from .uidreference import UIDReference


__all__: list[str] = [
    'APIModel',
    'APIModelField',
    'APIModelInspector',
    'APIResourceModel',
    'APIRootResourceModel',
    'APIVersionedMeta',
    'ClusterObjectReference',
    'DefaultInspector',
    'LocalObjectReference',
    'ObjectMeta',
    'ObjectReference',
    'ResourceSpec',
    'TypedLocalObjectReference',
    'UIDReference',
]

APIResourceType = APIResourceModel[Any] | APIRootResourceModel[Any]
DefaultInspector = APIModelInspector()